//
// Ƀc[/Xg\R|[lg
//      : Nana
// J : Borland Delphi6 Professional
//
// KvȃR|[lg :
// EA[JCoR|[lg for Delphi/C++Builder
//   Copyright(C) NORG1964/Masashi Yoneda 1997-2001
//   norg1964@ceres.dti.ne.jp
//
// XV :
//   v1.00 2003/01/26 J
//   v1.01 2003/01/27 vpeBC

unit ArcCtrls;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, ComCtrls,
  Archives;

const RootString = 'Root';  // [gm[h

type
  TCustomArcListView = class;

  { JX^Ƀc[r[ }
  TCustomArcTreeView = class(TCustomTreeView)
  private
  	FArchiveFilePath: String;
    FArcListView: TCustomArcListView;
    FShowAllList: Boolean;
    FShowTrees: Boolean;
  protected
    procedure CreateWnd; override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure Change(Node: TTreeNode); override;
    procedure SetArchiveFilePath(Path: String);
    procedure SetArcListView(ListView: TCustomArcListView);
    procedure SetShowAllList(ShowAllList: Boolean);
    procedure SetShowTrees(ShowTrees: Boolean);
    procedure ReadArchiveFile;
    procedure CreateArcNode(ParentNode: TTreeNode; TreePath: String);
    function GetSelectedTreePath: String;
    procedure SetTreePath(Path: String);
  public
    constructor Create(AOwner: TComponent); override;
    function GetTreePath(Node: TTreeNode): String;
    function GetTreeNode(TreePath: String): TTreeNode;
    property ArchiveFilePath: String read FArchiveFilePath write SetArchiveFilePath;
    property ArchiveTreePath: String read GetSelectedTreePath write SetTreePath;
  published
    property ArcListView: TCustomArcListView read FArcListView write SetArcListView;
    property ShowAllList: Boolean read FShowAllList write SetShowAllList;
    property ShowTrees: Boolean read FShowTrees write SetShowTrees;
  end;

  { Ƀc[r[ }
  TArcTreeView = class(TCustomArcTreeView)
  published
    property Align;
    property Anchors;
    property AutoExpand;
    property BevelEdges;
    property BevelInner;
    property BevelOuter;
    property BevelKind default bkNone;
    property BevelWidth;
    property BiDiMode;
    property BorderStyle;
    property BorderWidth;
    property ChangeDelay;
    property Color;
    property Ctl3D;
    property Constraints;
    property DragKind;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property HotTrack;
    property Images;
    property Indent;
    property MultiSelect;
    property MultiSelectStyle;
    property ParentBiDiMode;
    property ParentColor default False;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ReadOnly;
    property RightClickSelect;
    property RowSelect;
    property ShowButtons;
    property ShowHint;
    property ShowLines;
    property ShowRoot;
    property SortType;
    property StateImages;
    property TabOrder;
    property TabStop default True;
    property ToolTips;
    property Visible;
    property OnAddition;
    property OnAdvancedCustomDraw;
    property OnAdvancedCustomDrawItem;
    property OnChange;
    property OnChanging;
    property OnClick;
    property OnCollapsed;
    property OnCollapsing;
    property OnCompare;
    property OnContextPopup;
    property OnCreateNodeClass;
    property OnCustomDraw;
    property OnCustomDrawItem;
    property OnDblClick;
    property OnDeletion;
    property OnDragDrop;
    property OnDragOver;
    property OnEdited;
    property OnEditing;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnExpanding;
    property OnExpanded;
    property OnGetImageIndex;
    property OnGetSelectedIndex;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
    { Items must be published after OnGetImageIndex and OnGetSelectedIndex }
    property Items;
  end;

  { JX^ɃXgr[ }
  TCustomArcListView = class(TCustomListView)
  private
    FArchiveFilePath: String;
    FArchiveTreePath: String;
    FArcList: TList;
    FArcTreeView: TCustomArcTreeView;
    FSortStyle: Integer;      // \[g(1: -1:~)
    FSortedColumn: Integer;   // ǂ̃JŃ\[gĂ邩
                              // (-1:ǂ̃Jł\[gĂȂ 0`:J̃CfbNX)
    FShowFolder: Boolean;
  protected
    procedure SetArchiveFilePath(Path: String);
    procedure SetArchiveTreePath(Path: String);
    procedure SetArcTreeView(TreeView: TCustomArcTreeView);
    procedure SetShowFolder(ShowFolder: Boolean);
    procedure CreateWnd; override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure ColClick(Column: TListColumn); override;
    procedure ReadArchiveFile;
    procedure SetItemAttr(Item: TListItem; Info: PIndivisualInfo);
    procedure SortColumn(Index: Integer);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property ArchiveFilePath: String read FArchiveFilePath write SetArchiveFilePath;
    property ArchiveTreePath: String read FArchiveTreePath write SetArchiveTreePath;
  published
    property ArcTreeView: TCustomArcTreeView read FArcTreeView write SetArcTreeView;
    property ShowFolder: Boolean read FShowFolder write SetShowFolder;
  end;

  { ɃXgr[ }
  TArcListView = class(TCustomArcListView)
  published
    property Action;
    property Align;
    property AllocBy;
    property Anchors;
    property BevelEdges;
    property BevelInner;
    property BevelOuter;
    property BevelKind default bkNone;
    property BevelWidth;
    property BiDiMode;
    property BorderStyle;
    property BorderWidth;
    property Checkboxes;
    property Color;
    property Columns;
    property ColumnClick;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property FlatScrollBars;
    property FullDrag;
    property GridLines;
    property HideSelection;
    property HotTrack;
    property HotTrackStyles;
    property HoverTime;
    property IconOptions;
    property Items;
    property LargeImages;
    property MultiSelect;
    property OwnerData;
    property OwnerDraw;
    property ReadOnly default False;
    property RowSelect;
    property ParentBiDiMode;
    property ParentColor default False;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowColumnHeaders;
    property ShowWorkAreas;
    property ShowHint;
    property SmallImages;
    property SortType;
    property StateImages;
    property TabOrder;
    property TabStop default True;
    property ViewStyle;
    property Visible;
    property OnAdvancedCustomDraw;
    property OnAdvancedCustomDrawItem;
    property OnAdvancedCustomDrawSubItem;
    property OnChange;
    property OnChanging;
    property OnClick;
    property OnColumnClick;
    property OnColumnDragged;
    property OnColumnRightClick;
    property OnCompare;
    property OnContextPopup;
    property OnCustomDraw;
    property OnCustomDrawItem;
    property OnCustomDrawSubItem;
    property OnData;
    property OnDataFind;
    property OnDataHint;
    property OnDataStateChange;
    property OnDblClick;
    property OnDeletion;
    property OnDrawItem;
    property OnEdited;
    property OnEditing;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGetImageIndex;
    property OnGetSubItemImage;
    property OnDragDrop;
    property OnDragOver;
    property OnInfoTip;
    property OnInsert;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnSelectItem;
    property OnStartDock;
    property OnStartDrag;
  end;

procedure Register;


implementation

uses
  StrUtils, DateUtils, Commctrl, ShellAPI, ActiveX, ShlObj;

////////////////////////////////
// ֐
////////////////////////////////

{ IDEɓo^ }
procedure Register;
begin
  // A[JCoR|[lgƓpbgɒǉ
  RegisterComponents('NORG', [TArcTreeView]);
  RegisterComponents('NORG', [TArcListView]);
end;

{ tH_ACR̃C[WԍԂ }
function GetCloseFolderImageIndex(Handle: HWND): Integer;
var
  Malloc: IMalloc;
  ItemID: PItemIDList;
  SHFileInfo: TSHFileInfo;
begin
  SHGetMalloc(Malloc);
  // tH_ACR̐Ȏ擾@킩Ȃ̂ŁAuṽC[Wőp
  SHGetSpecialFolderLocation(Handle, CSIDL_SENDTO, ItemID);
  try
    SHGetFileInfo(PChar(ItemID), 0,
      SHFileInfo, Sizeof(TSHFileInfo),
      SHGFI_SYSICONINDEX or SHGFI_SMALLICON or SHGFI_PIDL);
      Result := SHFileInfo.iIcon;
  finally
    Malloc.Free(ItemID);
  end;
end;

{ JtH_ACR̃C[WԍԂ }
function GetOpenFolderImageIndex(Handle: HWND): Integer;
var
  Malloc: IMalloc;
  ItemID: PItemIDList;
  SHFileInfo: TSHFileInfo;
begin
  SHGetMalloc(Malloc);
  // JtH_ACR̐Ȏ擾@킩Ȃ̂ŁAuṽC[Wőp
  SHGetSpecialFolderLocation(Handle, CSIDL_SENDTO, ItemID);
  try
  SHGetFileInfo(PChar(ItemID), 0,
    SHFileInfo, Sizeof(TSHFileInfo),
    SHGFI_SYSICONINDEX or SHGFI_SMALLICON or SHGFI_OPENICON or SHGFI_PIDL);
    Result := SHFileInfo.iIcon;
  finally
    Malloc.Free(ItemID);
  end;
end;


////////////////////////////////
// Ƀc[r[
////////////////////////////////

constructor TCustomArcTreeView.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FArcListView := nil;
  FShowAllList := true;
  FShowTrees := true;
end;

procedure TCustomArcTreeView.CreateWnd;
var
  Malloc: IMalloc;
  DesktopID: PItemIDList;
  ImageList: HImageList;
  SHFileInfo: TSHFileInfo;
begin
  inherited CreateWnd;

  SHGetMalloc(Malloc);
  try
    // VFC[Wݒ
    SHGetSpecialFolderLocation(Handle, CSIDL_DESKTOP, DesktopID);
    ImageList := SHGetFileInfo(PChar(DesktopID), 0,
      SHFileInfo, Sizeof(TSHFileInfo),
      SHGFI_PIDL or SHGFI_SYSICONINDEX or SHGFI_SMALLICON);
    TreeView_SetImageList(Handle, ImageList, 0);
  finally
    Malloc.Free(DesktopID);
    Malloc := nil;
  end;
end;

procedure TCustomArcTreeView.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = FArcListView) then
    FArcListView := nil;
end;

procedure TCustomArcTreeView.Change(Node: TTreeNode);
begin
  if Assigned(FArcListView) then
    FArcListView.ArchiveTreePath := GetSelectedTreePath;
  inherited Change(Node);
end;

procedure TCustomArcTreeView.SetArchiveFilePath(Path: String);
begin
  if Path = EmptyStr then Exit;
  FArchiveFilePath := Path;
  ReadArchiveFile;
  if Assigned(FArcListView) then
  begin
    FArcListView.FArchiveFilePath := Path;
    FArcListView.ReadArchiveFile;
  end;
  Select(Items.GetFirstNode);
end;

procedure TCustomArcTreeView.SetArcListView(ListView: TCustomArcListView);
begin
  if ListView = FArcListView then Exit;
  if ListView <> nil then
  begin
    ListView.FArcTreeView := Self;
  end
  else
  begin
    if FArcListView <> nil then
      FArcListView.FArcTreeView := nil;
  end;
  if FArcListView <> nil then
    FArcListView.FreeNotification(Self);
  FArcListView := ListView;
end;

procedure TCustomArcTreeView.SetShowAllList(ShowAllList: Boolean);
begin
  FShowAllList := ShowAllList;
  if FArchiveFilePath = EmptyStr then Exit;
  ReadArchiveFile;
  if Items.Count > 0 then
  begin
    if Assigned(FArcListView) then
    begin
      FArcListView.ReadArchiveFile;
    end;
    Select(Items.GetFirstNode);
  end
  else
    FArcListView.ArchiveTreePath := EmptyStr;
end;

procedure TCustomArcTreeView.SetShowTrees(ShowTrees: Boolean);
begin
  FShowTrees := ShowTrees;
  if FArchiveFilePath = EmptyStr then Exit;
  ReadArchiveFile;
  if Items.Count > 0 then
  begin
    if Assigned(FArcListView) then
    begin
      FArcListView.ReadArchiveFile;
    end;
    Select(Items.GetFirstNode);
  end
  else
    FArcListView.ArchiveTreePath := EmptyStr;
end;

{ Ƀt@Cǂݍ݁Ac[\쐬 }
procedure TCustomArcTreeView.ReadArchiveFile;
  // Xg\[gۂ̔r֐
  function CompareListItem(Item1, Item2: Pointer): Integer;
  begin
    Result := CompareText(PIndivisualInfo(Item1).szFileName,
                          PIndivisualInfo(Item2).szFileName);
  end;
var
  ArcList: TList;
	ArchiveFile: TArchiveFile;
	IndivisualInfo: TIndivisualInfo;
  PInfo: PIndivisualInfo;
	done:	integer;
  SHFileInfo: TSHFileInfo;
  I: Integer;
  RootNode: TTreeNode;
begin
  if FArchiveFilePath = EmptyStr then Exit;

	ArchiveFile := TArchiveFile.Create(Self);
  ArcList := TList.Create;
	try
    Items.BeginUpdate;
    Items.Clear;

    // Ƀt@C̃ACeꗗ쐬
		ArchiveFile.FileName := FArchiveFilePath;
		ArchiveFile.FindOpen(Handle, 0);
		done := ArchiveFile.FindFirst('*.*', IndivisualInfo);
		while done = 0 do
    begin
      New(PInfo);
      PInfo^ := IndivisualInfo;
      ArcList.Add(PInfo);
			done := ArchiveFile.FindNext(IndivisualInfo);
		end;
		ArchiveFile.FindClose;
    ArcList.Sort(@CompareListItem);

    // ꗗm[h쐬
    if FShowAllList = true then
    begin
      RootNode := Items.Add(nil, ExtractFileName(FArchiveFilePath));

      SHGetFileInfo(PChar(ExtractFileName(FArchiveFilePath)), 0,
        SHFileInfo, Sizeof(TSHFileInfo),
        SHGFI_SYSICONINDEX or SHGFI_USEFILEATTRIBUTES or SHGFI_SMALLICON or SHGFI_TYPENAME);
      RootNode.ImageIndex := SHFileInfo.iIcon;

      SHGetFileInfo(PChar(ExtractFileName(FArchiveFilePath)), 0,
        SHFileInfo, Sizeof(TSHFileInfo),
        SHGFI_SYSICONINDEX or SHGFI_USEFILEATTRIBUTES or SHGFI_SMALLICON or SHGFI_OPENICON or SHGFI_TYPENAME);
      RootNode.SelectedIndex := SHFileInfo.iIcon;
    end;

    // c[쐬
    if FShowTrees = true then
    begin
      // [gm[h쐬
      RootNode := Items.Add(nil, RootString);
      RootNode.ImageIndex := GetCloseFolderImageIndex(Handle);
      RootNode.SelectedIndex := GetOpenFolderImageIndex(Handle);

      // [gȉɃc[쐬
      for I := 0 to ArcList.Count -1 do
      begin
        CreateArcNode(RootNode, PIndivisualInfo(ArcList[I]).szFileName);
      end;
    end;
	finally
    ArcList.Free;
		ArchiveFile.Free;
    Items.EndUpdate;
	end;
end;

{ c[m[h쐬 }
procedure TCustomArcTreeView.CreateArcNode(ParentNode: TTreeNode; TreePath: String);
var
  Token: String;
  ChildNode, NewNode: TTreeNode;
begin
  if Pos('/', TreePath) = 0 then Exit;

  // ŏ̎qm[h擾
  ChildNode := ParentNode.GetFirstChild;

  Token := Copy(TreePath, 0, Pos('/', TreePath)-1);

  // qm[hnil̏ꍇ́Aqm[h쐬āÅKwɍċA
  if ChildNode = nil then
  begin
    NewNode := Items.AddChild(ParentNode, Token);
    ParentNode.Expand(True);
    NewNode.ImageIndex := GetCloseFolderImageIndex(Handle);
    NewNode.SelectedIndex := GetOpenFolderImageIndex(Handle);
    ParentNode := ParentNode.GetFirstChild;
    CreateArcNode(ParentNode, Copy(TreePath, Length(Token)+2, Length(TreePath) - Length(Token)));
    Exit;
  end
  // qm[hꍇ́Aqm[hƈv邩ׂ
  else
  begin
    while ChildNode <> nil do
    begin
      // vqm[hꍇ́ÅKw𒲂ׂ邽ߍċA
      if ChildNode.Text = Token then
      begin
        CreateArcNode(ChildNode, Copy(TreePath, Length(Token)+2, Length(TreePath) - Length(Token)));
        Exit;
      end;
      ChildNode := ParentNode.GetNextChild(ChildNode);
    end;
  end;

  // vqm[hȂꍇ́Aqm[h쐬
  NewNode := Items.AddChild(ParentNode, Token);
  ParentNode.Expand(True);
  NewNode.ImageIndex := GetCloseFolderImageIndex(Handle);
  NewNode.SelectedIndex := GetOpenFolderImageIndex(Handle);
end;

{ c[r[ŌݑIĂʒũpXԂ }
function TCustomArcTreeView.GetSelectedTreePath: String;
begin
  Result := GetTreePath(Selected);
end;

{ c[r[̃pXݒ肷 }
procedure TCustomArcTreeView.SetTreePath(Path: String);
begin
  Select(GetTreeNode(Path));
end;

{ m[h̃pXԂ }
function TCustomArcTreeView.GetTreePath(Node: TTreeNode): String;
begin
  Result := '';
  while Node <> nil do
  begin
    Result := Node.Text + '/' + Result;
    Node := Node.Parent;
  end;
end;

{ pX̃m[hԂ }
function TCustomArcTreeView.GetTreeNode(TreePath: String): TTreeNode;
var
  Node: TTreeNode;
begin
  Node := Items.GetFirstNode;
  while Node <> nil do
  begin
    if GetTreePath(Node) = TreePath then
    begin
      Result := Node;
      Exit;
    end;
    Node := Node.GetNext;
  end;
  Result := nil;
end;


////////////////////////////////
// ɃXgr[
////////////////////////////////

constructor TCustomArcListView.Create(AOwner: TComponent);
var
  Column: TListColumn;
begin
  inherited Create(AOwner);
  FArcList := TList.Create;
  FArcTreeView := nil;

  Column := Columns.Add;
  Column.Caption := 't@C';
  Column.Width := 150;
  Column := Columns.Add;
  Column.Caption := 't@C̎';
  Column.Width := 100;
  Column := Columns.Add;
  Column.Caption := 'TCY';
  Column.Width := 100;
  Column.Alignment := taRightJustify;
  Column := Columns.Add;
  Column.Caption := 'kTCY';
  Column.Width := 100;
  Column.Alignment := taRightJustify;
  Column := Columns.Add;
  Column.Caption := 'k';
  Column.Width := 100;
  Column.Alignment := taRightJustify;
  Column := Columns.Add;
  Column.Caption := 'XV';
  Column.Width := 150;
//  Column := Columns.Add;
//  Column.Caption := 'k[h';
//  Column.Width := 150;
//  Column := Columns.Add;
//  Column.Caption := '';
//  Column.Width := 150;
//  Column := Columns.Add;
//  Column.Caption := 'CRC';
//  Column.Width := 150;
//  Column := Columns.Add;
//  Column.Caption := 'tO';
//  Column.Width := 150;
//  Column := Columns.Add;
//  Column.Caption := 'OS';
//  Column.Width := 150;
//  Column := Columns.Add;
//  Column.Caption := 'gf[^';
//  Column.Width := 150;
//  Column := Columns.Add;
//  Column.Caption := 'gf[^';
//  Column.Width := 150;
//  Column := Columns.Add;
//  Column.Caption := 'gf[^';
//  Column.Width := 150;

  FSortStyle := 1;
  FSortedColumn := 1; // -1 ɂƁA\[gĂȂԂŋN
end;

destructor TCustomArcListView.Destroy;
begin
  FArcList.Free;
  inherited Destroy;
end;

procedure TCustomArcListView.CreateWnd;
var
  Malloc: IMalloc;
  DesktopID: PItemIDList;
  ImageList: HImageList;
  SHFileInfo: TSHFileInfo;
begin
  inherited CreateWnd;

  SHGetMalloc(Malloc);
  try
    // VFC[Wݒ
    SHGetSpecialFolderLocation(Handle, CSIDL_DESKTOP, DesktopID);
    ImageList := SHGetFileInfo(PChar(DesktopID), 0,
      SHFileInfo, Sizeof(TSHFileInfo),
      SHGFI_PIDL or SHGFI_SYSICONINDEX or SHGFI_ICON);
    ListView_SetImageList(Handle, ImageList, LVSIL_NORMAL);
    ImageList := SHGetFileInfo(PChar(DesktopID), 0,
      SHFileInfo, Sizeof(TSHFileInfo),
      SHGFI_PIDL or SHGFI_SYSICONINDEX or SHGFI_SMALLICON);
    ListView_SetImageList(Handle, ImageList, LVSIL_SMALL);
  finally
    Malloc.Free(DesktopID);
    Malloc := nil;
  end;
end;

procedure TCustomArcListView.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = FArcTreeView) then
    FArcTreeView := nil
end;

procedure TCustomArcListView.ColClick(Column: TListColumn);
begin
  inherited ColClick(Column);

  if (FSortedColumn = -1) or (FSortedColumn <> Column.Index) then
    FSortStyle := 1
  else
    FSortStyle := -FSortStyle;
  FSortedColumn := Column.Index;
  SortColumn(Column.Index);
end;

procedure TCustomArcListView.SetArchiveFilePath(Path: String);
begin
  if Path = EmptyStr then Exit;

  if Assigned(FArcTreeView) then
    FArcTreeView.ArchiveFilePath := Path
  else
  begin
    FArchiveFilePath := Path;
    ReadArchiveFile;
  end;
end;

procedure TCustomArcListView.ReadArchiveFile;
var
	ArchiveFile: TArchiveFile;
	IndivisualInfo: TIndivisualInfo;
  PInfo: PIndivisualInfo;
	done:	integer;
begin
  if FArchiveFilePath = EmptyStr then Exit;

	ArchiveFile := TArchiveFile.Create(Self);
	try
    FArcList.Clear;

		ArchiveFile.FileName := FArchiveFilePath;
		ArchiveFile.FindOpen(Handle, 0);
		done := ArchiveFile.FindFirst('*.*', IndivisualInfo);
		while done = 0 do
    begin
      New(PInfo);
      PInfo^ := IndivisualInfo;
      FArcList.Add(PInfo);
			done := ArchiveFile.FindNext(IndivisualInfo);
		end;
		ArchiveFile.FindClose;
	finally
		ArchiveFile.Free;
	end;
end;

procedure TCustomArcListView.SetArchiveTreePath(Path: String);
var
  I: Integer;
  TreePath, FileName, TempStr: String;
  Item: TListItem;
begin
  if FArchiveFilePath = EmptyStr then Exit;

  FArchiveTreePath := Path;

  Items.BeginUpdate;
  Items.Clear;

  // pXɃt@C̏ꍇ́AׂẴt@CXgr[ɒǉ
  if Path = ExtractFileName(FArchiveFilePath) + '/' then
  begin
    for  I := 0 to FArcList.Count -1 do
    begin
      if AnsiStrLastChar(PIndivisualInfo(FArcList[I]).szFileName) <> '/' then
      begin
        Item := Items.Add;
        FileName := AnsiStrRScan(PIndivisualInfo(FArcList[I]).szFileName, '/');
        if FileName = EmptyStr then
          Item.Caption := PIndivisualInfo(FArcList[I]).szFileName
        else
          Item.Caption := Copy(FileName, 2, Length(FileName)-1);
        SetItemAttr(Item, PIndivisualInfo(FArcList[I]));
      end;
    end;
  end
  // [g̊Kw̏ꍇ́AJg̊Kw̃t@Ĉ݃Xgr[ɒǉ
  else if AnsiStartsStr(RootString + '/', Path) = True then
  begin
    TreePath := Copy(Path, Length(RootString) + 2, Length(Path) - Length(RootString));
    for I := 0 to FArcList.Count -1 do
    begin
      if AnsiStartsStr(TreePath, PIndivisualInfo(FArcList[I]).szFileName) = True then
      begin
        FileName := Copy(PIndivisualInfo(FArcList[I]).szFileName, Length(TreePath)+1,
          Length(PIndivisualInfo(FArcList[I]).szFileName) - Length(TreePath));

        //tH_ǉ
        if FShowFolder = True then
        begin
          if Pos('/', FileName) <> 0 then
          begin
            TempStr := Copy(FileName, 0, Pos('/', FileName)-1);
            if FindCaption(0, TempStr, False, True, False) = nil then
            begin
              Item := Items.Add;
              Item.Caption := TempStr;
              Item.SubItems.Add(EmptyStr);
              Item.SubItems.Add(EmptyStr);
              Item.SubItems.Add(EmptyStr);
              Item.SubItems.Add(EmptyStr);
              Item.SubItems.Add(EmptyStr);
              Item.Data := nil;
              Item.ImageIndex := GetCloseFolderImageIndex(Handle);
            end;
          end;
        end;

        // t@Cǉ
        if (Pos('/', FileName) = 0) and (FileName <> EmptyStr) then
        begin
          Item := Items.Add;
          Item.Caption := FileName;
          SetItemAttr(Item, PIndivisualInfo(FArcList[I]));
        end;
      end;
    end;
  end;

  SortColumn(FSortedColumn);

  Items.EndUpdate;

  if Assigned(FArcTreeView) then
  begin
    FArcTreeView.Select(FArcTreeView.GetTreeNode(Path));
  end;
end;


procedure TCustomArcListView.SetArcTreeView(TreeView: TCustomArcTreeView);
begin
  if TreeView = FArcTreeView then Exit;
  if TreeView <> nil then
  begin
    TreeView.FArcListView := Self;
  end
  else
  begin
    if FArcTreeView <> nil then
      FArcTreeView.FArcListView := nil;
  end;
  if FArcTreeView <> nil then
    FArcTreeView.FreeNotification(Self);
  FArcTreeView := TreeView;
end;

procedure TCustomArcListView.SetShowFolder(ShowFolder: Boolean);
begin
  FShowFolder := ShowFolder;
  ArchiveTreePath := FArchiveTreePath;
end;

{ XgACe̍ڂݒ肷 }
procedure TCustomArcListView.SetItemAttr(Item: TListItem; Info: PIndivisualInfo);
var
  SHFileInfo: TSHFileInfo;
  Date: TDateTime;
begin
  // t@C̊gqAΉC[Wݒ肷
  SHGetFileInfo(PChar(ExtractFileExt(Info.szFileName)), 0, SHFileInfo, Sizeof(TSHFileInfo),
    SHGFI_SYSICONINDEX or SHGFI_USEFILEATTRIBUTES or SHGFI_SMALLICON or SHGFI_TYPENAME);
  Item.ImageIndex := SHFileInfo.iIcon;

  Item.Data := Info;                                  // Sf[^ێ
  Item.SubItems.Add(SHFileInfo.szTypeName);           // t@C̎
  Item.SubItems.Add(IntToStr(Info.dwOriginalSize));   // TCY
  Item.SubItems.Add(IntToStr(Info.dwCompressedSize)); // kTCY
  Item.SubItems.Add(                                  // t@C̎
    FloatToStr(Extended(Info.wRatio / 10)) + '%');    // k
  Date :=                                             // t
    EncodeDateTime(
    (1980 + (Info.wDate and $FE00) shr 9),
    (Info.wDate and $01E0) shr 5,
    (Info.wDate and $001F),
    (Info.wTime and $F800) shr 11,
    (Info.wTime and $07C0) shr 5,
    (Info.wTime and $001F) shl 1,
    0);
  Item.SubItems.Add(FormatDateTime('yyyy/mm/dd hh:ss:nn', Date));
//  Item.SubItems.Add(Info.szMode);                     // k[h
//  Item.SubItems.Add(Info.szAttribute);                // 
//  Item.SubItems.Add(IntToStr(Info.dwCRC));            // CRC
//  Item.SubItems.Add(IntToStr(Info.uFlag));            // tO
//  Item.SubItems.Add(IntToStr(Info.uOSType));          // OS
//  Item.SubItems.Add(Info.WriteTime);                  // gf[^
//  Item.SubItems.Add(Info.AccessTime);                 // gf[^
//  Item.SubItems.Add(Info.CreateTime);                 // gf[^
end;

{ Xgr[̍ڂ\[g }
procedure TCustomArcListView.SortColumn(Index: Integer);
  { r̂߂̃[J֐Q }
  // t@CŔr
  function SortFileName(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
  begin
    Result := CompareText(Item1.Caption, Item2.Caption) * ParamSort;
  end;

  // t@C̎ނŔr
  function SortFileType(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
  begin
    if Item1.Data = nil then
      Result := -1 * ParamSort
    else
    if Item2.Data = nil then
      Result := 1 * ParamSort
    else
      Result := CompareText(Item1.SubItems[0], Item2.SubItems[0]) * ParamSort;
  end;

  // t@CTCYŔr
  function SortFileSize(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
  var
    Size1, Size2: Cardinal;
  begin
    if Item1.Data = nil then
      Result := -1 * ParamSort
    else
    if Item2.Data = nil then
      Result := 1 * ParamSort
    else
    begin
      Size1 := PIndivisualInfo(Item1.Data).dwOriginalSize;
      Size2 := PIndivisualInfo(Item2.Data).dwOriginalSize;
      if Size1 > Size2 then
        Result := 1
      else if Size1 < Size2 then
        Result := -1
      else
        Result := 0;
      Result := Result * ParamSort;
    end;
  end;

  // kt@CTCYŔr
  function SortCompressedFileSize(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
  var
    Size1, Size2: Cardinal;
  begin
    if Item1.Data = nil then
      Result := -1 * ParamSort
    else
    if Item2.Data = nil then
      Result := 1 * ParamSort
    else
    begin
      Size1 := PIndivisualInfo(Item1.Data).dwCompressedSize;
      Size2 := PIndivisualInfo(Item2.Data).dwCompressedSize;
      if Size1 > Size2 then
        Result := 1
      else if Size1 < Size2 then
        Result := -1
      else
        Result := 0;
      Result := Result * ParamSort;
    end;
  end;

  // kŔr
  function SortRatio(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
  var
    Ratio1, Ratio2: Word;
  begin
    if Item1.Data = nil then
      Result := -1 * ParamSort
    else
    if Item2.Data = nil then
      Result := 1 * ParamSort
    else
    begin
      Ratio1 := PIndivisualInfo(Item1.Data).wRatio;
      Ratio2 := PIndivisualInfo(Item2.Data).wRatio;
      if Ratio1 > Ratio2 then
        Result := 1
      else if Ratio1 < Ratio2 then
        Result := -1
      else
        Result := 0;
      Result := Result * ParamSort;
    end;
  end;

  // tŔr
  function SortDateTime(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
  var
    Info1, Info2: PIndivisualInfo;
    Date1, Date2: TDateTime;
  begin
    if Item1.Data = nil then
      Result := -1 * ParamSort
    else
    if Item2.Data = nil then
      Result := 1 * ParamSort
    else
    begin
      Info1 := PIndivisualInfo(Item1.Data);
      Info2 := PIndivisualInfo(Item2.Data);
      Date1 := EncodeDateTime(
        (1980 + (Info1.wDate and $FE00) shr 9),
        (Info1.wDate and $01E0) shr 5,
        (Info1.wDate and $001F),
        (Info1.wTime and $F800) shr 11,
        (Info1.wTime and $07C0) shr 5,
        (Info1.wTime and $001F) shl 1,
        0);
      Date2 := EncodeDateTime(
        (1980 + (Info2.wDate and $FE00) shr 9),
        (Info2.wDate and $01E0) shr 5,
        (Info2.wDate and $001F),
        (Info2.wTime and $F800) shr 11,
        (Info2.wTime and $07C0) shr 5,
        (Info2.wTime and $001F) shl 1,
        0);
      Result := CompareDateTime(Date1, Date2) * ParamSort;
    end;
  end;

begin
  case Index of
    0: CustomSort(@SortFileName, FSortStyle);
    1: CustomSort(@SortFileType, FSortStyle);
    2: CustomSort(@SortFileSize, FSortStyle);
    3: CustomSort(@SortCompressedFileSize, FSortStyle);
    4: CustomSort(@SortRatio, FSortStyle);
    5: CustomSort(@SortDateTime, FSortStyle);
  end;
end;

end.
